'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = function (_ref) {
  var t = _ref.types;

  return {
    visitor: {
      Program: function Program(path, state) {
        path.traverse({
          ClassMethod: function ClassMethod(path) {
            if (path.node.key.name !== 'render') {
              return;
            }

            var opts = _extends({}, defaults, state.opts);
            var cls = path.findParent(function (path) {
              return path.isClassDeclaration();
            });
            if (!opts.superClasses.includes(cls.node.superClass.name)) {
              return;
            }

            var params = path.get('params').slice(0, paramNames.length);
            if (!params.length) {
              return;
            }

            var body = path.get('body');
            var declarators = params.map(function (param, i) {
              return t.variableDeclarator(param.node, t.memberExpression(t.thisExpression(), t.identifier(paramNames[i])));
            });

            var declaration = t.variableDeclaration('const', declarators);
            body.unshiftContainer('body', declaration);

            params.forEach(function (param) {
              param.remove();
            });
          }
        });
      }
    }
  };
};

var defaults = {
  superClasses: ['Component', 'PureComponent']
};

var paramNames = ['props', 'state', 'context'];